local gamescene = {}

--アニメーション作成用ライブラリのanim8を読み出し。
local anim8 = require "scene.gamescene.anim8"
local image, animation

--ゲーム内プレイヤーに関するアニメーション用の変数を定義。
player_character_image = 0
player_walk_anime = 0
player_stop_anime = 0

--ステージBGMの変数をlocalで定義。
local stage_BGM = ""

function gamescene:enter()

    --ステージBGMを設定して鳴らす。
    stage_BGM = love.audio.newSource("sound/bgm/Mr.mp3","stream")
    stage_BGM:setLooping(true)
    stage_BGM:play()
    stage_BGM:setVolume(0.2)

    


    --クラス実装用ライブラリのclassicと参考元のluaファイルを読み出し。
    Object = require"library.classic"
    require"scene.gamescene.playerdate"
    require"scene.gamescene.bullet"

    if select_player == "AMATT" then

 

        --アマット移動時のアニメーションを作成。
        player_character_image = love.graphics.newImage("image/player/PD2_amattotati.png")
        local g = anim8.newGrid(16,32,player_character_image:getWidth(), player_character_image:getHeight())
        
        player_stop_anime = anim8.newAnimation(g(1,1),1)
        player_walk_anime = anim8.newAnimation(g("2-4",1),0.8)

        require"scene.gamescene.player_amatt"
        require"scene.gamescene.bullet_amattMain"

    elseif select_player == "HITY" then

        require"scene.gamescene.player_hity"


    end

    
    --それぞれのプレイヤーのluaファイルをp1に定義。
    p1 = Player_amatt()
    --p2 = Player_hity()

    --プレイヤーの弾を入れるテーブル。
    listOfBullets = {}


    require "scene.gamescene.enemy"
    e1 = Enemy()
    
    enemy_appearance = 5

end


function gamescene:update(dt)

    --最初のmain.luaからウインドウサイズ変更用関数を利用可能にする。
    windowResize()

    --baton関連動作の更新。
    input:update()

    --anim8のアニメーションを動かす関数。
    player_walk_anime:update(dt)

    p1:update(dt)

    e1:update(dt)


    for i,v in ipairs(listOfBullets) do
        v:update(dt)
    end


    if enemy_appearance >= 0 then
        enemy_appearance = enemy_appearance -1 * dt
    end
end

function gamescene:draw()

    simpleScale.set()

    --背景色を紫にする。
    love.graphics.setBackgroundColor( 0.2, 0, 0.5, 0.5 )

    p1:draw()

    e1:draw()

    for i,v in ipairs(listOfBullets) do
        v:draw()
    end


    simpleScale.unSet()
end


return gamescene